<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');

include 'db.php';
include 'authorization.php';
include 'functions.php';

// Get the raw POST data
$rawData = file_get_contents('php://input');

// Decode JSON data
$data = json_decode($rawData, true);

if (!$data) {
    echo json_encode(["message" => "Invalid JSON data received"]);
    exit();
}

// Validate required fields
if (empty($data['uID'])) {
    echo json_encode(["message" => "Missing required field: uID"]);
    exit();
}

$uID = $data['uID'];
$learnerID = $data['learnerID'];
$sessionresponse = $data['sessionresponse'];  // Store sessionresponse object

// Since sessionresponse is an object, directly access its properties
$quesID = $sessionresponse['quesID'];
$title = $sessionresponse['title'];
$response = $sessionresponse['response'];

$query1 = "SELECT * FROM question_update WHERE learnerID='$learnerID' AND instructID='$uID' AND quesID='$quesID'";
$result = $conn->query($query1);

if ($result->num_rows > 0) {
    echo json_encode(["message" => "Question Repeated"]);
} else {
    $query = "INSERT INTO `question_update`(`quesID`, `title`, `response`, `learnerID`, `instructID`) 
              VALUES ('$quesID','$title','$response','$learnerID','$uID')";
    if ($conn->query($query) === TRUE) {
        if ($response == "Skill Achieved") {
            $query = "UPDATE users SET skillpoints = skillpoints + 1 WHERE uID = '$learnerID'";
            $conn->query($query);
        }
        echo json_encode(["message" => "Response Submit Successful!"]);
    } else {
        echo json_encode(["message" => "Error: " . $conn->error]);
    }
}

$conn->close();
?>
